#pragma once
class asITypeInfo;
class asIScriptObject;
class asIScriptFunction;

namespace Deer {
    namespace EditorEngine {
        struct DockPanelObject {
        private:
            asITypeInfo* type = nullptr;
            asIScriptObject* object = nullptr;
            asIScriptFunction* renderFunction = nullptr;
            asIScriptFunction* menuBarFunction = nullptr;
            bool isValid = false;

        public:
            DockPanelObject(asITypeInfo*);
            ~DockPanelObject();
            // Delete copy constructor
            DockPanelObject(const DockPanelObject&) = delete;
            DockPanelObject& operator=(const DockPanelObject&) = delete;

            DockPanelObject(DockPanelObject&& other) noexcept;
            DockPanelObject& operator=(DockPanelObject&& other) noexcept;

            void executeRender();
            void invalidate();
        };
    }
}